/* valaobjectcreationexpression.c generated by valac, the Vala compiler
 * generated from valaobjectcreationexpression.vala, do not modify */

/* valaobjectcreationexpression.vala
 *
 * Copyright (C) 2006-2012  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include "vala.h"
#include <glib.h>
#include <valagee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_iterator_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterator_unref (var), NULL)))

struct _ValaObjectCreationExpressionPrivate {
	gboolean _is_yield_expression;
	gboolean _struct_creation;
	ValaList* argument_list;
	ValaList* object_initializer;
	ValaDataType* _data_type;
	ValaMemberAccess* _member_name;
};

static gint ValaObjectCreationExpression_private_offset;
static gpointer vala_object_creation_expression_parent_class = NULL;

static void vala_object_creation_expression_real_accept (ValaCodeNode* base,
                                                  ValaCodeVisitor* visitor);
static void vala_object_creation_expression_real_accept_children (ValaCodeNode* base,
                                                           ValaCodeVisitor* visitor);
static void vala_object_creation_expression_real_replace_expression (ValaCodeNode* base,
                                                              ValaExpression* old_node,
                                                              ValaExpression* new_node);
static gboolean vala_object_creation_expression_real_is_pure (ValaExpression* base);
static gboolean vala_object_creation_expression_real_is_accessible (ValaExpression* base,
                                                             ValaSymbol* sym);
static void vala_object_creation_expression_real_replace_type (ValaCodeNode* base,
                                                        ValaDataType* old_type,
                                                        ValaDataType* new_type);
static gboolean vala_object_creation_expression_real_check (ValaCodeNode* base,
                                                     ValaCodeContext* context);
static void vala_object_creation_expression_real_get_error_types (ValaCodeNode* base,
                                                           ValaCollection* collection,
                                                           ValaSourceReference* source_reference);
static void vala_object_creation_expression_real_emit (ValaCodeNode* base,
                                                ValaCodeGenerator* codegen);
static void vala_object_creation_expression_real_get_defined_variables (ValaCodeNode* base,
                                                                 ValaCollection* collection);
static void vala_object_creation_expression_real_get_used_variables (ValaCodeNode* base,
                                                              ValaCollection* collection);
static void vala_object_creation_expression_finalize (ValaCodeNode * obj);

static inline gpointer
vala_object_creation_expression_get_instance_private (ValaObjectCreationExpression* self)
{
	return G_STRUCT_MEMBER_P (self, ValaObjectCreationExpression_private_offset);
}

/**
 * Creates a new object creation expression.
 *
 * @param member_name      object type to create
 * @param source_reference reference to source code
 * @return                 newly created object creation expression
 */
ValaObjectCreationExpression*
vala_object_creation_expression_construct (GType object_type,
                                           ValaMemberAccess* member_name,
                                           ValaSourceReference* source_reference)
{
	ValaObjectCreationExpression* self = NULL;
	self = (ValaObjectCreationExpression*) vala_expression_construct (object_type);
	vala_code_node_set_source_reference ((ValaCodeNode*) self, source_reference);
	vala_object_creation_expression_set_member_name (self, member_name);
	return self;
}

ValaObjectCreationExpression*
vala_object_creation_expression_new (ValaMemberAccess* member_name,
                                     ValaSourceReference* source_reference)
{
	return vala_object_creation_expression_construct (VALA_TYPE_OBJECT_CREATION_EXPRESSION, member_name, source_reference);
}

/**
 * Appends the specified expression to the list of arguments.
 *
 * @param arg an argument
 */
void
vala_object_creation_expression_add_argument (ValaObjectCreationExpression* self,
                                              ValaExpression* arg)
{
	ValaList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (arg != NULL);
	_tmp0_ = self->priv->argument_list;
	vala_collection_add ((ValaCollection*) _tmp0_, arg);
	vala_code_node_set_parent_node ((ValaCodeNode*) arg, (ValaCodeNode*) self);
}

/**
 * Returns a copy of the argument list.
 *
 * @return argument list
 */
static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

ValaList*
vala_object_creation_expression_get_argument_list (ValaObjectCreationExpression* self)
{
	ValaList* _tmp0_;
	ValaList* _tmp1_;
	ValaList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->argument_list;
	_tmp1_ = _vala_iterable_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

/**
 * Appends the specified member initializer to the object initializer.
 *
 * @param init a member initializer
 */
void
vala_object_creation_expression_add_member_initializer (ValaObjectCreationExpression* self,
                                                        ValaMemberInitializer* init)
{
	ValaList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (init != NULL);
	_tmp0_ = self->priv->object_initializer;
	vala_collection_add ((ValaCollection*) _tmp0_, init);
	vala_code_node_set_parent_node ((ValaCodeNode*) init, (ValaCodeNode*) self);
}

/**
 * Returns the object initializer.
 *
 * @return member initializer list
 */
ValaList*
vala_object_creation_expression_get_object_initializer (ValaObjectCreationExpression* self)
{
	ValaList* _tmp0_;
	ValaList* _tmp1_;
	ValaList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->object_initializer;
	_tmp1_ = _vala_iterable_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

static void
vala_object_creation_expression_real_accept (ValaCodeNode* base,
                                             ValaCodeVisitor* visitor)
{
	ValaObjectCreationExpression * self;
	self = (ValaObjectCreationExpression*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_object_creation_expression (visitor, self);
	vala_code_visitor_visit_expression (visitor, (ValaExpression*) self);
}

static void
vala_object_creation_expression_real_accept_children (ValaCodeNode* base,
                                                      ValaCodeVisitor* visitor)
{
	ValaObjectCreationExpression * self;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	ValaMemberAccess* _tmp4_;
	ValaMemberAccess* _tmp5_;
	self = (ValaObjectCreationExpression*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = vala_object_creation_expression_get_type_reference (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		ValaDataType* _tmp2_;
		ValaDataType* _tmp3_;
		_tmp2_ = vala_object_creation_expression_get_type_reference (self);
		_tmp3_ = _tmp2_;
		vala_code_node_accept ((ValaCodeNode*) _tmp3_, visitor);
	}
	_tmp4_ = vala_object_creation_expression_get_member_name (self);
	_tmp5_ = _tmp4_;
	if (_tmp5_ != NULL) {
		ValaMemberAccess* _tmp6_;
		ValaMemberAccess* _tmp7_;
		_tmp6_ = vala_object_creation_expression_get_member_name (self);
		_tmp7_ = _tmp6_;
		vala_code_node_accept ((ValaCodeNode*) _tmp7_, visitor);
	}
	{
		ValaList* _arg_list = NULL;
		ValaList* _tmp8_;
		ValaList* _tmp9_;
		gint _arg_size = 0;
		ValaList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _arg_index = 0;
		_tmp8_ = self->priv->argument_list;
		_tmp9_ = _vala_iterable_ref0 (_tmp8_);
		_arg_list = _tmp9_;
		_tmp10_ = _arg_list;
		_tmp11_ = vala_collection_get_size ((ValaCollection*) _tmp10_);
		_tmp12_ = _tmp11_;
		_arg_size = _tmp12_;
		_arg_index = -1;
		while (TRUE) {
			ValaExpression* arg = NULL;
			ValaList* _tmp13_;
			gpointer _tmp14_;
			ValaExpression* _tmp15_;
			_arg_index = _arg_index + 1;
			if (!(_arg_index < _arg_size)) {
				break;
			}
			_tmp13_ = _arg_list;
			_tmp14_ = vala_list_get (_tmp13_, _arg_index);
			arg = (ValaExpression*) _tmp14_;
			_tmp15_ = arg;
			vala_code_node_accept ((ValaCodeNode*) _tmp15_, visitor);
			_vala_code_node_unref0 (arg);
		}
		_vala_iterable_unref0 (_arg_list);
	}
	{
		ValaList* _init_list = NULL;
		ValaList* _tmp16_;
		ValaList* _tmp17_;
		gint _init_size = 0;
		ValaList* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gint _init_index = 0;
		_tmp16_ = self->priv->object_initializer;
		_tmp17_ = _vala_iterable_ref0 (_tmp16_);
		_init_list = _tmp17_;
		_tmp18_ = _init_list;
		_tmp19_ = vala_collection_get_size ((ValaCollection*) _tmp18_);
		_tmp20_ = _tmp19_;
		_init_size = _tmp20_;
		_init_index = -1;
		while (TRUE) {
			ValaMemberInitializer* init = NULL;
			ValaList* _tmp21_;
			gpointer _tmp22_;
			ValaMemberInitializer* _tmp23_;
			_init_index = _init_index + 1;
			if (!(_init_index < _init_size)) {
				break;
			}
			_tmp21_ = _init_list;
			_tmp22_ = vala_list_get (_tmp21_, _init_index);
			init = (ValaMemberInitializer*) _tmp22_;
			_tmp23_ = init;
			vala_code_node_accept ((ValaCodeNode*) _tmp23_, visitor);
			_vala_code_node_unref0 (init);
		}
		_vala_iterable_unref0 (_init_list);
	}
}

static void
vala_object_creation_expression_real_replace_expression (ValaCodeNode* base,
                                                         ValaExpression* old_node,
                                                         ValaExpression* new_node)
{
	ValaObjectCreationExpression * self;
	gint index = 0;
	ValaList* _tmp0_;
	self = (ValaObjectCreationExpression*) base;
	g_return_if_fail (old_node != NULL);
	g_return_if_fail (new_node != NULL);
	_tmp0_ = self->priv->argument_list;
	index = vala_list_index_of (_tmp0_, old_node);
	if (index >= 0) {
		ValaList* _tmp1_;
		_tmp1_ = self->priv->argument_list;
		vala_list_set (_tmp1_, index, new_node);
		vala_code_node_set_parent_node ((ValaCodeNode*) new_node, (ValaCodeNode*) self);
	}
}

static gboolean
vala_object_creation_expression_real_is_pure (ValaExpression* base)
{
	ValaObjectCreationExpression * self;
	gboolean result = FALSE;
	self = (ValaObjectCreationExpression*) base;
	result = FALSE;
	return result;
}

static gboolean
vala_object_creation_expression_real_is_accessible (ValaExpression* base,
                                                    ValaSymbol* sym)
{
	ValaObjectCreationExpression * self;
	gboolean _tmp0_ = FALSE;
	ValaMemberAccess* _tmp1_;
	ValaMemberAccess* _tmp2_;
	gboolean result = FALSE;
	self = (ValaObjectCreationExpression*) base;
	g_return_val_if_fail (sym != NULL, FALSE);
	_tmp1_ = vala_object_creation_expression_get_member_name (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		ValaMemberAccess* _tmp3_;
		ValaMemberAccess* _tmp4_;
		_tmp3_ = vala_object_creation_expression_get_member_name (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = !vala_expression_is_accessible ((ValaExpression*) _tmp4_, sym);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	{
		ValaList* _arg_list = NULL;
		ValaList* _tmp5_;
		ValaList* _tmp6_;
		gint _arg_size = 0;
		ValaList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _arg_index = 0;
		_tmp5_ = self->priv->argument_list;
		_tmp6_ = _vala_iterable_ref0 (_tmp5_);
		_arg_list = _tmp6_;
		_tmp7_ = _arg_list;
		_tmp8_ = vala_collection_get_size ((ValaCollection*) _tmp7_);
		_tmp9_ = _tmp8_;
		_arg_size = _tmp9_;
		_arg_index = -1;
		while (TRUE) {
			ValaExpression* arg = NULL;
			ValaList* _tmp10_;
			gpointer _tmp11_;
			ValaExpression* _tmp12_;
			_arg_index = _arg_index + 1;
			if (!(_arg_index < _arg_size)) {
				break;
			}
			_tmp10_ = _arg_list;
			_tmp11_ = vala_list_get (_tmp10_, _arg_index);
			arg = (ValaExpression*) _tmp11_;
			_tmp12_ = arg;
			if (!vala_expression_is_accessible (_tmp12_, sym)) {
				result = FALSE;
				_vala_code_node_unref0 (arg);
				_vala_iterable_unref0 (_arg_list);
				return result;
			}
			_vala_code_node_unref0 (arg);
		}
		_vala_iterable_unref0 (_arg_list);
	}
	{
		ValaList* _init_list = NULL;
		ValaList* _tmp13_;
		ValaList* _tmp14_;
		gint _init_size = 0;
		ValaList* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint _init_index = 0;
		_tmp13_ = self->priv->object_initializer;
		_tmp14_ = _vala_iterable_ref0 (_tmp13_);
		_init_list = _tmp14_;
		_tmp15_ = _init_list;
		_tmp16_ = vala_collection_get_size ((ValaCollection*) _tmp15_);
		_tmp17_ = _tmp16_;
		_init_size = _tmp17_;
		_init_index = -1;
		while (TRUE) {
			ValaMemberInitializer* init = NULL;
			ValaList* _tmp18_;
			gpointer _tmp19_;
			ValaMemberInitializer* _tmp20_;
			ValaExpression* _tmp21_;
			ValaExpression* _tmp22_;
			_init_index = _init_index + 1;
			if (!(_init_index < _init_size)) {
				break;
			}
			_tmp18_ = _init_list;
			_tmp19_ = vala_list_get (_tmp18_, _init_index);
			init = (ValaMemberInitializer*) _tmp19_;
			_tmp20_ = init;
			_tmp21_ = vala_member_initializer_get_initializer (_tmp20_);
			_tmp22_ = _tmp21_;
			if (!vala_expression_is_accessible (_tmp22_, sym)) {
				result = FALSE;
				_vala_code_node_unref0 (init);
				_vala_iterable_unref0 (_init_list);
				return result;
			}
			_vala_code_node_unref0 (init);
		}
		_vala_iterable_unref0 (_init_list);
	}
	result = TRUE;
	return result;
}

static void
vala_object_creation_expression_real_replace_type (ValaCodeNode* base,
                                                   ValaDataType* old_type,
                                                   ValaDataType* new_type)
{
	ValaObjectCreationExpression * self;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	self = (ValaObjectCreationExpression*) base;
	g_return_if_fail (old_type != NULL);
	g_return_if_fail (new_type != NULL);
	_tmp0_ = vala_object_creation_expression_get_type_reference (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_type) {
		vala_object_creation_expression_set_type_reference (self, new_type);
	}
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

static gboolean
vala_object_creation_expression_real_check (ValaCodeNode* base,
                                            ValaCodeContext* context)
{
	ValaObjectCreationExpression * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaMemberAccess* _tmp4_;
	ValaMemberAccess* _tmp5_;
	ValaTypeSymbol* type = NULL;
	ValaDataType* _tmp8_;
	ValaDataType* _tmp9_;
	ValaDataType* _tmp106_;
	ValaDataType* _tmp107_;
	ValaDataType* _tmp108_;
	ValaDataType* _tmp109_;
	ValaDataType* _tmp110_;
	ValaDataType* _tmp111_;
	gint given_num_type_args = 0;
	ValaDataType* _tmp112_;
	ValaDataType* _tmp113_;
	ValaList* _tmp114_;
	ValaList* _tmp115_;
	gint _tmp116_;
	gint _tmp117_;
	gint _tmp118_;
	gint expected_num_type_args = 0;
	ValaTypeSymbol* _tmp119_;
	gboolean _tmp247_ = FALSE;
	ValaSymbol* _tmp248_;
	ValaSymbol* _tmp249_;
	ValaSymbol* _tmp261_;
	ValaSymbol* _tmp262_;
	gboolean _tmp496_;
	gboolean _tmp497_;
	gboolean _tmp550_;
	gboolean _tmp551_;
	gboolean result = FALSE;
	self = (ValaObjectCreationExpression*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_object_creation_expression_get_member_name (self);
	_tmp5_ = _tmp4_;
	if (_tmp5_ != NULL) {
		ValaMemberAccess* _tmp6_;
		ValaMemberAccess* _tmp7_;
		_tmp6_ = vala_object_creation_expression_get_member_name (self);
		_tmp7_ = _tmp6_;
		if (!vala_code_node_check ((ValaCodeNode*) _tmp7_, context)) {
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			result = FALSE;
			return result;
		}
	}
	type = NULL;
	_tmp8_ = vala_object_creation_expression_get_type_reference (self);
	_tmp9_ = _tmp8_;
	if (_tmp9_ == NULL) {
		ValaMemberAccess* _tmp10_;
		ValaMemberAccess* _tmp11_;
		ValaMemberAccess* _tmp14_;
		ValaMemberAccess* _tmp15_;
		ValaSymbol* _tmp16_;
		ValaSymbol* _tmp17_;
		ValaSymbol* constructor_sym = NULL;
		ValaMemberAccess* _tmp18_;
		ValaMemberAccess* _tmp19_;
		ValaSymbol* _tmp20_;
		ValaSymbol* _tmp21_;
		ValaSymbol* _tmp22_;
		ValaSymbol* type_sym = NULL;
		ValaMemberAccess* _tmp23_;
		ValaMemberAccess* _tmp24_;
		ValaSymbol* _tmp25_;
		ValaSymbol* _tmp26_;
		ValaSymbol* _tmp27_;
		ValaList* type_args = NULL;
		ValaMemberAccess* _tmp28_;
		ValaMemberAccess* _tmp29_;
		ValaList* _tmp30_;
		ValaSymbol* _tmp31_;
		ValaSymbol* _tmp55_;
		_tmp10_ = vala_object_creation_expression_get_member_name (self);
		_tmp11_ = _tmp10_;
		if (_tmp11_ == NULL) {
			ValaSourceReference* _tmp12_;
			ValaSourceReference* _tmp13_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp12_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp13_ = _tmp12_;
			vala_report_error (_tmp13_, "Incomplete object creation expression");
			result = FALSE;
			_vala_code_node_unref0 (type);
			return result;
		}
		_tmp14_ = vala_object_creation_expression_get_member_name (self);
		_tmp15_ = _tmp14_;
		_tmp16_ = vala_expression_get_symbol_reference ((ValaExpression*) _tmp15_);
		_tmp17_ = _tmp16_;
		if (_tmp17_ == NULL) {
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			result = FALSE;
			_vala_code_node_unref0 (type);
			return result;
		}
		_tmp18_ = vala_object_creation_expression_get_member_name (self);
		_tmp19_ = _tmp18_;
		_tmp20_ = vala_expression_get_symbol_reference ((ValaExpression*) _tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = _vala_code_node_ref0 (_tmp21_);
		constructor_sym = _tmp22_;
		_tmp23_ = vala_object_creation_expression_get_member_name (self);
		_tmp24_ = _tmp23_;
		_tmp25_ = vala_expression_get_symbol_reference ((ValaExpression*) _tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = _vala_code_node_ref0 (_tmp26_);
		type_sym = _tmp27_;
		_tmp28_ = vala_object_creation_expression_get_member_name (self);
		_tmp29_ = _tmp28_;
		_tmp30_ = vala_member_access_get_type_arguments (_tmp29_);
		type_args = _tmp30_;
		_tmp31_ = constructor_sym;
		if (VALA_IS_METHOD (_tmp31_)) {
			ValaSymbol* _tmp32_;
			ValaSymbol* _tmp33_;
			ValaSymbol* _tmp34_;
			ValaSymbol* _tmp35_;
			ValaMethod* constructor = NULL;
			ValaSymbol* _tmp36_;
			ValaMethod* _tmp37_;
			ValaSymbol* _tmp38_;
			ValaMethod* _tmp46_;
			ValaMemberAccess* ma = NULL;
			ValaMemberAccess* _tmp47_;
			ValaMemberAccess* _tmp48_;
			ValaExpression* _tmp49_;
			ValaExpression* _tmp50_;
			ValaMemberAccess* _tmp51_;
			ValaMemberAccess* _tmp52_;
			_tmp32_ = constructor_sym;
			_tmp33_ = vala_symbol_get_parent_symbol (_tmp32_);
			_tmp34_ = _tmp33_;
			_tmp35_ = _vala_code_node_ref0 (_tmp34_);
			_vala_code_node_unref0 (type_sym);
			type_sym = _tmp35_;
			_tmp36_ = constructor_sym;
			_tmp37_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, VALA_TYPE_METHOD, ValaMethod));
			constructor = _tmp37_;
			_tmp38_ = constructor_sym;
			if (!VALA_IS_CREATION_METHOD (_tmp38_)) {
				ValaSourceReference* _tmp39_;
				ValaSourceReference* _tmp40_;
				ValaMethod* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp39_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp40_ = _tmp39_;
				_tmp41_ = constructor;
				_tmp42_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp41_);
				_tmp43_ = _tmp42_;
				_tmp44_ = g_strdup_printf ("`%s' is not a creation method", _tmp43_);
				_tmp45_ = _tmp44_;
				vala_report_error (_tmp40_, _tmp45_);
				_g_free0 (_tmp45_);
				_g_free0 (_tmp43_);
				result = FALSE;
				_vala_code_node_unref0 (constructor);
				_vala_iterable_unref0 (type_args);
				_vala_code_node_unref0 (type_sym);
				_vala_code_node_unref0 (constructor_sym);
				_vala_code_node_unref0 (type);
				return result;
			}
			_tmp46_ = constructor;
			vala_expression_set_symbol_reference ((ValaExpression*) self, (ValaSymbol*) _tmp46_);
			_tmp47_ = vala_object_creation_expression_get_member_name (self);
			_tmp48_ = _tmp47_;
			_tmp49_ = vala_member_access_get_inner (_tmp48_);
			_tmp50_ = _tmp49_;
			_tmp51_ = _vala_code_node_ref0 (VALA_IS_MEMBER_ACCESS (_tmp50_) ? ((ValaMemberAccess*) _tmp50_) : NULL);
			ma = _tmp51_;
			_tmp52_ = ma;
			if (_tmp52_ != NULL) {
				ValaMemberAccess* _tmp53_;
				ValaList* _tmp54_;
				_tmp53_ = ma;
				_tmp54_ = vala_member_access_get_type_arguments (_tmp53_);
				_vala_iterable_unref0 (type_args);
				type_args = _tmp54_;
			}
			_vala_code_node_unref0 (ma);
			_vala_code_node_unref0 (constructor);
		}
		_tmp55_ = type_sym;
		if (VALA_IS_CLASS (_tmp55_)) {
			ValaSymbol* _tmp56_;
			ValaTypeSymbol* _tmp57_;
			ValaTypeSymbol* _tmp58_;
			gboolean _tmp59_;
			gboolean _tmp60_;
			_tmp56_ = type_sym;
			_tmp57_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol));
			_vala_code_node_unref0 (type);
			type = _tmp57_;
			_tmp58_ = type;
			_tmp59_ = vala_class_get_is_error_base (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, VALA_TYPE_CLASS, ValaClass));
			_tmp60_ = _tmp59_;
			if (_tmp60_) {
				ValaSourceReference* _tmp61_;
				ValaSourceReference* _tmp62_;
				ValaErrorType* _tmp63_;
				ValaErrorType* _tmp64_;
				_tmp61_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp62_ = _tmp61_;
				_tmp63_ = vala_error_type_new (NULL, NULL, _tmp62_);
				_tmp64_ = _tmp63_;
				vala_object_creation_expression_set_type_reference (self, (ValaDataType*) _tmp64_);
				_vala_code_node_unref0 (_tmp64_);
			} else {
				ValaTypeSymbol* _tmp65_;
				ValaObjectType* _tmp66_;
				ValaObjectType* _tmp67_;
				_tmp65_ = type;
				_tmp66_ = vala_object_type_new ((ValaObjectTypeSymbol*) G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, VALA_TYPE_CLASS, ValaClass));
				_tmp67_ = _tmp66_;
				vala_object_creation_expression_set_type_reference (self, (ValaDataType*) _tmp67_);
				_vala_code_node_unref0 (_tmp67_);
			}
		} else {
			ValaSymbol* _tmp68_;
			_tmp68_ = type_sym;
			if (VALA_IS_STRUCT (_tmp68_)) {
				ValaSymbol* _tmp69_;
				ValaTypeSymbol* _tmp70_;
				ValaTypeSymbol* _tmp71_;
				ValaStructValueType* _tmp72_;
				ValaStructValueType* _tmp73_;
				_tmp69_ = type_sym;
				_tmp70_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol));
				_vala_code_node_unref0 (type);
				type = _tmp70_;
				_tmp71_ = type;
				_tmp72_ = vala_struct_value_type_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, VALA_TYPE_STRUCT, ValaStruct));
				_tmp73_ = _tmp72_;
				vala_object_creation_expression_set_type_reference (self, (ValaDataType*) _tmp73_);
				_vala_code_node_unref0 (_tmp73_);
			} else {
				ValaSymbol* _tmp74_;
				_tmp74_ = type_sym;
				if (VALA_IS_ERROR_CODE (_tmp74_)) {
					ValaSymbol* _tmp75_;
					ValaSymbol* _tmp76_;
					ValaSymbol* _tmp77_;
					ValaSymbol* _tmp78_;
					ValaSourceReference* _tmp79_;
					ValaSourceReference* _tmp80_;
					ValaErrorType* _tmp81_;
					ValaErrorType* _tmp82_;
					ValaSymbol* _tmp83_;
					_tmp75_ = type_sym;
					_tmp76_ = vala_symbol_get_parent_symbol (_tmp75_);
					_tmp77_ = _tmp76_;
					_tmp78_ = type_sym;
					_tmp79_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp80_ = _tmp79_;
					_tmp81_ = vala_error_type_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, VALA_TYPE_ERROR_DOMAIN, ValaErrorDomain), G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, VALA_TYPE_ERROR_CODE, ValaErrorCode), _tmp80_);
					_tmp82_ = _tmp81_;
					vala_object_creation_expression_set_type_reference (self, (ValaDataType*) _tmp82_);
					_vala_code_node_unref0 (_tmp82_);
					_tmp83_ = type_sym;
					vala_expression_set_symbol_reference ((ValaExpression*) self, _tmp83_);
				} else {
					ValaSourceReference* _tmp84_;
					ValaSourceReference* _tmp85_;
					ValaSymbol* _tmp86_;
					gchar* _tmp87_;
					gchar* _tmp88_;
					gchar* _tmp89_;
					gchar* _tmp90_;
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					_tmp84_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp85_ = _tmp84_;
					_tmp86_ = type_sym;
					_tmp87_ = vala_symbol_get_full_name (_tmp86_);
					_tmp88_ = _tmp87_;
					_tmp89_ = g_strdup_printf ("`%s' is not a class, struct, or error code", _tmp88_);
					_tmp90_ = _tmp89_;
					vala_report_error (_tmp85_, _tmp90_);
					_g_free0 (_tmp90_);
					_g_free0 (_tmp88_);
					result = FALSE;
					_vala_iterable_unref0 (type_args);
					_vala_code_node_unref0 (type_sym);
					_vala_code_node_unref0 (constructor_sym);
					_vala_code_node_unref0 (type);
					return result;
				}
			}
		}
		{
			ValaList* _type_arg_list = NULL;
			ValaList* _tmp91_;
			ValaList* _tmp92_;
			gint _type_arg_size = 0;
			ValaList* _tmp93_;
			gint _tmp94_;
			gint _tmp95_;
			gint _type_arg_index = 0;
			_tmp91_ = type_args;
			_tmp92_ = _vala_iterable_ref0 (_tmp91_);
			_type_arg_list = _tmp92_;
			_tmp93_ = _type_arg_list;
			_tmp94_ = vala_collection_get_size ((ValaCollection*) _tmp93_);
			_tmp95_ = _tmp94_;
			_type_arg_size = _tmp95_;
			_type_arg_index = -1;
			while (TRUE) {
				ValaDataType* type_arg = NULL;
				ValaList* _tmp96_;
				gpointer _tmp97_;
				ValaDataType* _tmp98_;
				ValaDataType* _tmp99_;
				ValaDataType* _tmp100_;
				_type_arg_index = _type_arg_index + 1;
				if (!(_type_arg_index < _type_arg_size)) {
					break;
				}
				_tmp96_ = _type_arg_list;
				_tmp97_ = vala_list_get (_tmp96_, _type_arg_index);
				type_arg = (ValaDataType*) _tmp97_;
				_tmp98_ = vala_object_creation_expression_get_type_reference (self);
				_tmp99_ = _tmp98_;
				_tmp100_ = type_arg;
				vala_data_type_add_type_argument (_tmp99_, _tmp100_);
				_vala_code_node_unref0 (type_arg);
			}
			_vala_iterable_unref0 (_type_arg_list);
		}
		_vala_iterable_unref0 (type_args);
		_vala_code_node_unref0 (type_sym);
		_vala_code_node_unref0 (constructor_sym);
	} else {
		ValaDataType* _tmp101_;
		ValaDataType* _tmp102_;
		ValaTypeSymbol* _tmp103_;
		ValaTypeSymbol* _tmp104_;
		ValaTypeSymbol* _tmp105_;
		_tmp101_ = vala_object_creation_expression_get_type_reference (self);
		_tmp102_ = _tmp101_;
		_tmp103_ = vala_data_type_get_data_type (_tmp102_);
		_tmp104_ = _tmp103_;
		_tmp105_ = _vala_code_node_ref0 (_tmp104_);
		_vala_code_node_unref0 (type);
		type = _tmp105_;
	}
	_tmp106_ = vala_object_creation_expression_get_type_reference (self);
	_tmp107_ = _tmp106_;
	_tmp108_ = vala_data_type_copy (_tmp107_);
	_tmp109_ = _tmp108_;
	vala_expression_set_value_type ((ValaExpression*) self, _tmp109_);
	_vala_code_node_unref0 (_tmp109_);
	_tmp110_ = vala_expression_get_value_type ((ValaExpression*) self);
	_tmp111_ = _tmp110_;
	vala_data_type_set_value_owned (_tmp111_, TRUE);
	_tmp112_ = vala_object_creation_expression_get_type_reference (self);
	_tmp113_ = _tmp112_;
	_tmp114_ = vala_data_type_get_type_arguments (_tmp113_);
	_tmp115_ = _tmp114_;
	_tmp116_ = vala_collection_get_size ((ValaCollection*) _tmp115_);
	_tmp117_ = _tmp116_;
	_tmp118_ = _tmp117_;
	_vala_iterable_unref0 (_tmp115_);
	given_num_type_args = _tmp118_;
	expected_num_type_args = 0;
	_tmp119_ = type;
	if (VALA_IS_CLASS (_tmp119_)) {
		ValaClass* cl = NULL;
		ValaTypeSymbol* _tmp120_;
		ValaClass* _tmp121_;
		ValaClass* _tmp122_;
		ValaList* _tmp123_;
		ValaList* _tmp124_;
		gint _tmp125_;
		gint _tmp126_;
		gboolean _tmp127_;
		ValaClass* _tmp130_;
		gboolean _tmp131_;
		gboolean _tmp132_;
		ValaSymbol* _tmp140_;
		ValaSymbol* _tmp141_;
		gboolean _tmp162_ = FALSE;
		ValaSymbol* _tmp163_;
		ValaSymbol* _tmp164_;
		_tmp120_ = type;
		_tmp121_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp120_, VALA_TYPE_CLASS, ValaClass));
		cl = _tmp121_;
		_tmp122_ = cl;
		_tmp123_ = vala_object_type_symbol_get_type_parameters ((ValaObjectTypeSymbol*) _tmp122_);
		_tmp124_ = _tmp123_;
		_tmp125_ = vala_collection_get_size ((ValaCollection*) _tmp124_);
		_tmp126_ = _tmp125_;
		expected_num_type_args = _tmp126_;
		_vala_iterable_unref0 (_tmp124_);
		_tmp127_ = self->priv->_struct_creation;
		if (_tmp127_) {
			ValaSourceReference* _tmp128_;
			ValaSourceReference* _tmp129_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp128_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp129_ = _tmp128_;
			vala_report_error (_tmp129_, "syntax error, use `new' to create new objects");
			result = FALSE;
			_vala_code_node_unref0 (cl);
			_vala_code_node_unref0 (type);
			return result;
		}
		_tmp130_ = cl;
		_tmp131_ = vala_class_get_is_abstract (_tmp130_);
		_tmp132_ = _tmp131_;
		if (_tmp132_) {
			ValaSourceReference* _tmp133_;
			ValaSourceReference* _tmp134_;
			ValaClass* _tmp135_;
			gchar* _tmp136_;
			gchar* _tmp137_;
			gchar* _tmp138_;
			gchar* _tmp139_;
			vala_expression_set_value_type ((ValaExpression*) self, NULL);
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp133_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp134_ = _tmp133_;
			_tmp135_ = cl;
			_tmp136_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp135_);
			_tmp137_ = _tmp136_;
			_tmp138_ = g_strdup_printf ("Can't create instance of abstract class `%s'", _tmp137_);
			_tmp139_ = _tmp138_;
			vala_report_error (_tmp134_, _tmp139_);
			_g_free0 (_tmp139_);
			_g_free0 (_tmp137_);
			result = FALSE;
			_vala_code_node_unref0 (cl);
			_vala_code_node_unref0 (type);
			return result;
		}
		_tmp140_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
		_tmp141_ = _tmp140_;
		if (_tmp141_ == NULL) {
			ValaClass* _tmp142_;
			ValaCreationMethod* _tmp143_;
			ValaCreationMethod* _tmp144_;
			ValaSymbol* _tmp145_;
			ValaSymbol* _tmp146_;
			ValaSymbol* _tmp154_;
			ValaSymbol* _tmp155_;
			ValaSymbol* _tmp156_;
			ValaSymbol* _tmp157_;
			ValaVersionAttribute* _tmp158_;
			ValaVersionAttribute* _tmp159_;
			ValaSourceReference* _tmp160_;
			ValaSourceReference* _tmp161_;
			_tmp142_ = cl;
			_tmp143_ = vala_class_get_default_construction_method (_tmp142_);
			_tmp144_ = _tmp143_;
			vala_expression_set_symbol_reference ((ValaExpression*) self, (ValaSymbol*) _tmp144_);
			_tmp145_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
			_tmp146_ = _tmp145_;
			if (_tmp146_ == NULL) {
				ValaSourceReference* _tmp147_;
				ValaSourceReference* _tmp148_;
				ValaClass* _tmp149_;
				gchar* _tmp150_;
				gchar* _tmp151_;
				gchar* _tmp152_;
				gchar* _tmp153_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp147_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp148_ = _tmp147_;
				_tmp149_ = cl;
				_tmp150_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp149_);
				_tmp151_ = _tmp150_;
				_tmp152_ = g_strdup_printf ("`%s' does not have a default constructor", _tmp151_);
				_tmp153_ = _tmp152_;
				vala_report_error (_tmp148_, _tmp153_);
				_g_free0 (_tmp153_);
				_g_free0 (_tmp151_);
				result = FALSE;
				_vala_code_node_unref0 (cl);
				_vala_code_node_unref0 (type);
				return result;
			}
			_tmp154_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
			_tmp155_ = _tmp154_;
			vala_symbol_set_used (_tmp155_, TRUE);
			_tmp156_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
			_tmp157_ = _tmp156_;
			_tmp158_ = vala_symbol_get_version (_tmp157_);
			_tmp159_ = _tmp158_;
			_tmp160_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp161_ = _tmp160_;
			vala_version_attribute_check (_tmp159_, _tmp161_);
		}
		_tmp163_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
		_tmp164_ = _tmp163_;
		if (_tmp164_ != NULL) {
			gboolean _tmp165_ = FALSE;
			ValaSymbol* _tmp166_;
			ValaSymbol* _tmp167_;
			ValaSymbolAccessibility _tmp168_;
			ValaSymbolAccessibility _tmp169_;
			_tmp166_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
			_tmp167_ = _tmp166_;
			_tmp168_ = vala_symbol_get_access (_tmp167_);
			_tmp169_ = _tmp168_;
			if (_tmp169_ == VALA_SYMBOL_ACCESSIBILITY_PRIVATE) {
				_tmp165_ = TRUE;
			} else {
				ValaSymbol* _tmp170_;
				ValaSymbol* _tmp171_;
				ValaSymbolAccessibility _tmp172_;
				ValaSymbolAccessibility _tmp173_;
				_tmp170_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
				_tmp171_ = _tmp170_;
				_tmp172_ = vala_symbol_get_access (_tmp171_);
				_tmp173_ = _tmp172_;
				_tmp165_ = _tmp173_ == VALA_SYMBOL_ACCESSIBILITY_PROTECTED;
			}
			_tmp162_ = _tmp165_;
		} else {
			_tmp162_ = FALSE;
		}
		if (_tmp162_) {
			gboolean in_target_type = FALSE;
			in_target_type = FALSE;
			{
				ValaSymbol* this_symbol = NULL;
				ValaSemanticAnalyzer* _tmp174_;
				ValaSemanticAnalyzer* _tmp175_;
				ValaSymbol* _tmp176_;
				ValaSymbol* _tmp177_;
				ValaSymbol* _tmp178_;
				_tmp174_ = vala_code_context_get_analyzer (context);
				_tmp175_ = _tmp174_;
				_tmp176_ = vala_semantic_analyzer_get_current_symbol (_tmp175_);
				_tmp177_ = _tmp176_;
				_tmp178_ = _vala_code_node_ref0 (_tmp177_);
				this_symbol = _tmp178_;
				{
					gboolean _tmp179_ = FALSE;
					_tmp179_ = TRUE;
					while (TRUE) {
						ValaSymbol* _tmp184_;
						ValaSymbol* _tmp185_;
						ValaClass* _tmp186_;
						if (!_tmp179_) {
							ValaSymbol* _tmp180_;
							ValaSymbol* _tmp181_;
							ValaSymbol* _tmp182_;
							ValaSymbol* _tmp183_;
							_tmp180_ = this_symbol;
							_tmp181_ = vala_symbol_get_parent_symbol (_tmp180_);
							_tmp182_ = _tmp181_;
							_tmp183_ = _vala_code_node_ref0 (_tmp182_);
							_vala_code_node_unref0 (this_symbol);
							this_symbol = _tmp183_;
						}
						_tmp179_ = FALSE;
						_tmp184_ = this_symbol;
						if (!(_tmp184_ != NULL)) {
							break;
						}
						_tmp185_ = this_symbol;
						_tmp186_ = cl;
						if (_tmp185_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp186_, VALA_TYPE_SYMBOL, ValaSymbol)) {
							in_target_type = TRUE;
							break;
						}
					}
				}
				_vala_code_node_unref0 (this_symbol);
			}
			if (!in_target_type) {
				ValaSourceReference* _tmp187_;
				ValaSourceReference* _tmp188_;
				ValaSymbol* _tmp189_;
				ValaSymbol* _tmp190_;
				gchar* _tmp191_;
				gchar* _tmp192_;
				gchar* _tmp193_;
				gchar* _tmp194_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp187_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp188_ = _tmp187_;
				_tmp189_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
				_tmp190_ = _tmp189_;
				_tmp191_ = vala_symbol_get_full_name (_tmp190_);
				_tmp192_ = _tmp191_;
				_tmp193_ = g_strdup_printf ("Access to non-public constructor `%s' denied", _tmp192_);
				_tmp194_ = _tmp193_;
				vala_report_error (_tmp188_, _tmp194_);
				_g_free0 (_tmp194_);
				_g_free0 (_tmp192_);
				result = FALSE;
				_vala_code_node_unref0 (cl);
				_vala_code_node_unref0 (type);
				return result;
			}
		}
		while (TRUE) {
			ValaClass* _tmp195_;
			ValaClass* _tmp196_;
			gchar* _tmp197_;
			gchar* _tmp198_;
			gboolean _tmp199_;
			ValaClass* _tmp202_;
			ValaClass* _tmp203_;
			ValaClass* _tmp204_;
			ValaClass* _tmp205_;
			_tmp195_ = cl;
			if (!(_tmp195_ != NULL)) {
				break;
			}
			_tmp196_ = cl;
			_tmp197_ = vala_code_node_get_attribute_string ((ValaCodeNode*) _tmp196_, "CCode", "ref_sink_function", NULL);
			_tmp198_ = _tmp197_;
			_tmp199_ = _tmp198_ != NULL;
			_g_free0 (_tmp198_);
			if (_tmp199_) {
				ValaDataType* _tmp200_;
				ValaDataType* _tmp201_;
				_tmp200_ = vala_expression_get_value_type ((ValaExpression*) self);
				_tmp201_ = _tmp200_;
				vala_data_type_set_floating_reference (_tmp201_, TRUE);
				break;
			}
			_tmp202_ = cl;
			_tmp203_ = vala_class_get_base_class (_tmp202_);
			_tmp204_ = _tmp203_;
			_tmp205_ = _vala_code_node_ref0 (_tmp204_);
			_vala_code_node_unref0 (cl);
			cl = _tmp205_;
		}
		_vala_code_node_unref0 (cl);
	} else {
		ValaTypeSymbol* _tmp206_;
		_tmp206_ = type;
		if (VALA_IS_STRUCT (_tmp206_)) {
			ValaStruct* st = NULL;
			ValaTypeSymbol* _tmp207_;
			ValaStruct* _tmp208_;
			ValaStruct* _tmp209_;
			ValaList* _tmp210_;
			ValaList* _tmp211_;
			gint _tmp212_;
			gint _tmp213_;
			gboolean _tmp214_ = FALSE;
			gboolean _tmp215_;
			ValaSymbol* _tmp220_;
			ValaSymbol* _tmp221_;
			gboolean _tmp225_ = FALSE;
			gboolean _tmp226_ = FALSE;
			gboolean _tmp227_ = FALSE;
			ValaProfile _tmp228_;
			ValaProfile _tmp229_;
			_tmp207_ = type;
			_tmp208_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp207_, VALA_TYPE_STRUCT, ValaStruct));
			st = _tmp208_;
			_tmp209_ = st;
			_tmp210_ = vala_struct_get_type_parameters (_tmp209_);
			_tmp211_ = _tmp210_;
			_tmp212_ = vala_collection_get_size ((ValaCollection*) _tmp211_);
			_tmp213_ = _tmp212_;
			expected_num_type_args = _tmp213_;
			_vala_iterable_unref0 (_tmp211_);
			_tmp215_ = self->priv->_struct_creation;
			if (!_tmp215_) {
				gboolean _tmp216_;
				gboolean _tmp217_;
				_tmp216_ = vala_code_context_get_deprecated (context);
				_tmp217_ = _tmp216_;
				_tmp214_ = !_tmp217_;
			} else {
				_tmp214_ = FALSE;
			}
			if (_tmp214_) {
				ValaSourceReference* _tmp218_;
				ValaSourceReference* _tmp219_;
				_tmp218_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp219_ = _tmp218_;
				vala_report_warning (_tmp219_, "deprecated syntax, don't use `new' to initialize structs");
			}
			_tmp220_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
			_tmp221_ = _tmp220_;
			if (_tmp221_ == NULL) {
				ValaStruct* _tmp222_;
				ValaCreationMethod* _tmp223_;
				ValaCreationMethod* _tmp224_;
				_tmp222_ = st;
				_tmp223_ = vala_struct_get_default_construction_method (_tmp222_);
				_tmp224_ = _tmp223_;
				vala_expression_set_symbol_reference ((ValaExpression*) self, (ValaSymbol*) _tmp224_);
			}
			_tmp228_ = vala_code_context_get_profile (context);
			_tmp229_ = _tmp228_;
			if (_tmp229_ == VALA_PROFILE_GOBJECT) {
				ValaStruct* _tmp230_;
				_tmp230_ = st;
				_tmp227_ = vala_struct_is_simple_type (_tmp230_);
			} else {
				_tmp227_ = FALSE;
			}
			if (_tmp227_) {
				ValaSymbol* _tmp231_;
				ValaSymbol* _tmp232_;
				_tmp231_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
				_tmp232_ = _tmp231_;
				_tmp226_ = _tmp232_ == NULL;
			} else {
				_tmp226_ = FALSE;
			}
			if (_tmp226_) {
				ValaList* _tmp233_;
				gint _tmp234_;
				gint _tmp235_;
				_tmp233_ = self->priv->object_initializer;
				_tmp234_ = vala_collection_get_size ((ValaCollection*) _tmp233_);
				_tmp235_ = _tmp234_;
				_tmp225_ = _tmp235_ == 0;
			} else {
				_tmp225_ = FALSE;
			}
			if (_tmp225_) {
				ValaSourceReference* _tmp236_;
				ValaSourceReference* _tmp237_;
				ValaStruct* _tmp238_;
				gchar* _tmp239_;
				gchar* _tmp240_;
				gchar* _tmp241_;
				gchar* _tmp242_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp236_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp237_ = _tmp236_;
				_tmp238_ = st;
				_tmp239_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp238_);
				_tmp240_ = _tmp239_;
				_tmp241_ = g_strdup_printf ("`%s' does not have a default constructor", _tmp240_);
				_tmp242_ = _tmp241_;
				vala_report_error (_tmp237_, _tmp242_);
				_g_free0 (_tmp242_);
				_g_free0 (_tmp240_);
				result = FALSE;
				_vala_code_node_unref0 (st);
				_vala_code_node_unref0 (type);
				return result;
			}
			_vala_code_node_unref0 (st);
		}
	}
	if (expected_num_type_args > given_num_type_args) {
		ValaSourceReference* _tmp243_;
		ValaSourceReference* _tmp244_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp243_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp244_ = _tmp243_;
		vala_report_error (_tmp244_, "too few type arguments");
		result = FALSE;
		_vala_code_node_unref0 (type);
		return result;
	} else {
		if (expected_num_type_args < given_num_type_args) {
			ValaSourceReference* _tmp245_;
			ValaSourceReference* _tmp246_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp245_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp246_ = _tmp245_;
			vala_report_error (_tmp246_, "too many type arguments");
			result = FALSE;
			_vala_code_node_unref0 (type);
			return result;
		}
	}
	_tmp248_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
	_tmp249_ = _tmp248_;
	if (_tmp249_ == NULL) {
		ValaList* _tmp250_;
		ValaList* _tmp251_;
		gint _tmp252_;
		gint _tmp253_;
		_tmp250_ = vala_object_creation_expression_get_argument_list (self);
		_tmp251_ = _tmp250_;
		_tmp252_ = vala_collection_get_size ((ValaCollection*) _tmp251_);
		_tmp253_ = _tmp252_;
		_tmp247_ = _tmp253_ != 0;
		_vala_iterable_unref0 (_tmp251_);
	} else {
		_tmp247_ = FALSE;
	}
	if (_tmp247_) {
		ValaSourceReference* _tmp254_;
		ValaSourceReference* _tmp255_;
		ValaTypeSymbol* _tmp256_;
		gchar* _tmp257_;
		gchar* _tmp258_;
		gchar* _tmp259_;
		gchar* _tmp260_;
		vala_expression_set_value_type ((ValaExpression*) self, NULL);
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp254_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp255_ = _tmp254_;
		_tmp256_ = type;
		_tmp257_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp256_);
		_tmp258_ = _tmp257_;
		_tmp259_ = g_strdup_printf ("No arguments allowed when constructing type `%s'", _tmp258_);
		_tmp260_ = _tmp259_;
		vala_report_error (_tmp255_, _tmp260_);
		_g_free0 (_tmp260_);
		_g_free0 (_tmp258_);
		result = FALSE;
		_vala_code_node_unref0 (type);
		return result;
	}
	_tmp261_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
	_tmp262_ = _tmp261_;
	if (VALA_IS_METHOD (_tmp262_)) {
		ValaMethod* m = NULL;
		ValaSymbol* _tmp263_;
		ValaSymbol* _tmp264_;
		ValaMethod* _tmp265_;
		gboolean _tmp266_;
		ValaExpression* last_arg = NULL;
		ValaList* args = NULL;
		ValaList* _tmp285_;
		ValaIterator* arg_it = NULL;
		ValaList* _tmp286_;
		ValaIterator* _tmp287_;
		ValaMethod* _tmp316_;
		gboolean _tmp317_;
		gboolean _tmp318_;
		ValaSemanticAnalyzer* _tmp375_;
		ValaSemanticAnalyzer* _tmp376_;
		ValaMethod* _tmp377_;
		ValaMethodType* _tmp378_;
		ValaMethodType* _tmp379_;
		ValaMethod* _tmp380_;
		ValaList* _tmp381_;
		ValaList* _tmp382_;
		ValaList* _tmp383_;
		_tmp263_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
		_tmp264_ = _tmp263_;
		_tmp265_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp264_, VALA_TYPE_METHOD, ValaMethod));
		m = _tmp265_;
		_tmp266_ = self->priv->_is_yield_expression;
		if (_tmp266_) {
			ValaMethod* _tmp267_;
			gboolean _tmp268_;
			gboolean _tmp269_;
			gboolean _tmp272_ = FALSE;
			ValaSemanticAnalyzer* _tmp273_;
			ValaSemanticAnalyzer* _tmp274_;
			ValaMethod* _tmp275_;
			ValaMethod* _tmp276_;
			_tmp267_ = m;
			_tmp268_ = vala_method_get_coroutine (_tmp267_);
			_tmp269_ = _tmp268_;
			if (!_tmp269_) {
				ValaSourceReference* _tmp270_;
				ValaSourceReference* _tmp271_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp270_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp271_ = _tmp270_;
				vala_report_error (_tmp271_, "yield expression requires async method");
			}
			_tmp273_ = vala_code_context_get_analyzer (context);
			_tmp274_ = _tmp273_;
			_tmp275_ = vala_semantic_analyzer_get_current_method (_tmp274_);
			_tmp276_ = _tmp275_;
			if (_tmp276_ == NULL) {
				_tmp272_ = TRUE;
			} else {
				ValaSemanticAnalyzer* _tmp277_;
				ValaSemanticAnalyzer* _tmp278_;
				ValaMethod* _tmp279_;
				ValaMethod* _tmp280_;
				gboolean _tmp281_;
				gboolean _tmp282_;
				_tmp277_ = vala_code_context_get_analyzer (context);
				_tmp278_ = _tmp277_;
				_tmp279_ = vala_semantic_analyzer_get_current_method (_tmp278_);
				_tmp280_ = _tmp279_;
				_tmp281_ = vala_method_get_coroutine (_tmp280_);
				_tmp282_ = _tmp281_;
				_tmp272_ = !_tmp282_;
			}
			if (_tmp272_) {
				ValaSourceReference* _tmp283_;
				ValaSourceReference* _tmp284_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp283_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp284_ = _tmp283_;
				vala_report_error (_tmp284_, "yield expression not available outside async method");
			}
		}
		last_arg = NULL;
		_tmp285_ = vala_object_creation_expression_get_argument_list (self);
		args = _tmp285_;
		_tmp286_ = args;
		_tmp287_ = vala_iterable_iterator ((ValaIterable*) _tmp286_);
		arg_it = _tmp287_;
		{
			ValaList* _param_list = NULL;
			ValaMethod* _tmp288_;
			ValaList* _tmp289_;
			gint _param_size = 0;
			ValaList* _tmp290_;
			gint _tmp291_;
			gint _tmp292_;
			gint _param_index = 0;
			_tmp288_ = m;
			_tmp289_ = vala_callable_get_parameters ((ValaCallable*) _tmp288_);
			_param_list = _tmp289_;
			_tmp290_ = _param_list;
			_tmp291_ = vala_collection_get_size ((ValaCollection*) _tmp290_);
			_tmp292_ = _tmp291_;
			_param_size = _tmp292_;
			_param_index = -1;
			while (TRUE) {
				ValaParameter* param = NULL;
				ValaList* _tmp293_;
				gpointer _tmp294_;
				ValaParameter* _tmp295_;
				ValaParameter* _tmp296_;
				gboolean _tmp297_;
				gboolean _tmp298_;
				ValaIterator* _tmp299_;
				_param_index = _param_index + 1;
				if (!(_param_index < _param_size)) {
					break;
				}
				_tmp293_ = _param_list;
				_tmp294_ = vala_list_get (_tmp293_, _param_index);
				param = (ValaParameter*) _tmp294_;
				_tmp295_ = param;
				if (!vala_code_node_check ((ValaCodeNode*) _tmp295_, context)) {
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				}
				_tmp296_ = param;
				_tmp297_ = vala_parameter_get_ellipsis (_tmp296_);
				_tmp298_ = _tmp297_;
				if (_tmp298_) {
					_vala_code_node_unref0 (param);
					break;
				}
				_tmp299_ = arg_it;
				if (vala_iterator_next (_tmp299_)) {
					ValaExpression* arg = NULL;
					ValaIterator* _tmp300_;
					gpointer _tmp301_;
					ValaExpression* _tmp302_;
					ValaParameter* _tmp303_;
					ValaDataType* _tmp304_;
					ValaDataType* _tmp305_;
					ValaExpression* _tmp306_;
					ValaExpression* _tmp307_;
					ValaDataType* _tmp308_;
					ValaDataType* _tmp309_;
					ValaDataType* _tmp310_;
					ValaDataType* _tmp311_;
					ValaDataType* _tmp312_;
					ValaDataType* _tmp313_;
					ValaExpression* _tmp314_;
					ValaExpression* _tmp315_;
					_tmp300_ = arg_it;
					_tmp301_ = vala_iterator_get (_tmp300_);
					arg = (ValaExpression*) _tmp301_;
					_tmp302_ = arg;
					_tmp303_ = param;
					_tmp304_ = vala_variable_get_variable_type ((ValaVariable*) _tmp303_);
					_tmp305_ = _tmp304_;
					vala_expression_set_formal_target_type (_tmp302_, _tmp305_);
					_tmp306_ = arg;
					_tmp307_ = arg;
					_tmp308_ = vala_expression_get_formal_target_type (_tmp307_);
					_tmp309_ = _tmp308_;
					_tmp310_ = vala_expression_get_value_type ((ValaExpression*) self);
					_tmp311_ = _tmp310_;
					_tmp312_ = vala_data_type_get_actual_type (_tmp309_, _tmp311_, NULL, (ValaCodeNode*) self);
					_tmp313_ = _tmp312_;
					vala_expression_set_target_type (_tmp306_, _tmp313_);
					_vala_code_node_unref0 (_tmp313_);
					_tmp314_ = arg;
					_tmp315_ = _vala_code_node_ref0 (_tmp314_);
					_vala_code_node_unref0 (last_arg);
					last_arg = _tmp315_;
					_vala_code_node_unref0 (arg);
				}
				_vala_code_node_unref0 (param);
			}
			_vala_iterable_unref0 (_param_list);
		}
		_tmp316_ = m;
		_tmp317_ = vala_method_get_printf_format (_tmp316_);
		_tmp318_ = _tmp317_;
		if (_tmp318_) {
			ValaStringLiteral* format_literal = NULL;
			ValaExpression* _tmp319_;
			ValaStringLiteral* _tmp358_;
			format_literal = NULL;
			_tmp319_ = last_arg;
			if (VALA_IS_NULL_LITERAL (_tmp319_)) {
			} else {
				ValaExpression* _tmp320_;
				_tmp320_ = last_arg;
				if (_tmp320_ != NULL) {
					ValaExpression* _tmp321_;
					ValaStringLiteral* _tmp322_;
					gboolean _tmp323_ = FALSE;
					ValaStringLiteral* _tmp324_;
					_tmp321_ = last_arg;
					_tmp322_ = vala_string_literal_get_format_literal (_tmp321_);
					_vala_code_node_unref0 (format_literal);
					format_literal = _tmp322_;
					_tmp324_ = format_literal;
					if (_tmp324_ == NULL) {
						ValaList* _tmp325_;
						gint _tmp326_;
						gint _tmp327_;
						ValaMethod* _tmp328_;
						ValaList* _tmp329_;
						ValaList* _tmp330_;
						gint _tmp331_;
						gint _tmp332_;
						_tmp325_ = args;
						_tmp326_ = vala_collection_get_size ((ValaCollection*) _tmp325_);
						_tmp327_ = _tmp326_;
						_tmp328_ = m;
						_tmp329_ = vala_callable_get_parameters ((ValaCallable*) _tmp328_);
						_tmp330_ = _tmp329_;
						_tmp331_ = vala_collection_get_size ((ValaCollection*) _tmp330_);
						_tmp332_ = _tmp331_;
						_tmp323_ = _tmp327_ == (_tmp332_ - 1);
						_vala_iterable_unref0 (_tmp330_);
					} else {
						_tmp323_ = FALSE;
					}
					if (_tmp323_) {
						ValaStringLiteral* _tmp333_;
						ValaStringLiteral* _tmp334_;
						ValaSemanticAnalyzer* _tmp335_;
						ValaSemanticAnalyzer* _tmp336_;
						ValaDataType* _tmp337_;
						ValaDataType* _tmp338_;
						ValaDataType* _tmp339_;
						ValaList* _tmp340_;
						ValaList* _tmp341_;
						gint _tmp342_;
						gint _tmp343_;
						ValaStringLiteral* _tmp344_;
						ValaList* _tmp345_;
						ValaIterator* _tmp346_;
						_tmp333_ = vala_string_literal_new ("\"%s\"", NULL);
						_vala_code_node_unref0 (format_literal);
						format_literal = _tmp333_;
						_tmp334_ = format_literal;
						_tmp335_ = vala_code_context_get_analyzer (context);
						_tmp336_ = _tmp335_;
						_tmp337_ = _tmp336_->string_type;
						_tmp338_ = vala_data_type_copy (_tmp337_);
						_tmp339_ = _tmp338_;
						vala_expression_set_target_type ((ValaExpression*) _tmp334_, _tmp339_);
						_vala_code_node_unref0 (_tmp339_);
						_tmp340_ = self->priv->argument_list;
						_tmp341_ = args;
						_tmp342_ = vala_collection_get_size ((ValaCollection*) _tmp341_);
						_tmp343_ = _tmp342_;
						_tmp344_ = format_literal;
						vala_list_insert (_tmp340_, _tmp343_ - 1, (ValaExpression*) _tmp344_);
						_tmp345_ = self->priv->argument_list;
						_tmp346_ = vala_iterable_iterator ((ValaIterable*) _tmp345_);
						_vala_iterator_unref0 (arg_it);
						arg_it = _tmp346_;
						{
							ValaList* _param_list = NULL;
							ValaMethod* _tmp347_;
							ValaList* _tmp348_;
							gint _param_size = 0;
							ValaList* _tmp349_;
							gint _tmp350_;
							gint _tmp351_;
							gint _param_index = 0;
							_tmp347_ = m;
							_tmp348_ = vala_callable_get_parameters ((ValaCallable*) _tmp347_);
							_param_list = _tmp348_;
							_tmp349_ = _param_list;
							_tmp350_ = vala_collection_get_size ((ValaCollection*) _tmp349_);
							_tmp351_ = _tmp350_;
							_param_size = _tmp351_;
							_param_index = -1;
							while (TRUE) {
								ValaParameter* param = NULL;
								ValaList* _tmp352_;
								gpointer _tmp353_;
								ValaParameter* _tmp354_;
								gboolean _tmp355_;
								gboolean _tmp356_;
								ValaIterator* _tmp357_;
								_param_index = _param_index + 1;
								if (!(_param_index < _param_size)) {
									break;
								}
								_tmp352_ = _param_list;
								_tmp353_ = vala_list_get (_tmp352_, _param_index);
								param = (ValaParameter*) _tmp353_;
								_tmp354_ = param;
								_tmp355_ = vala_parameter_get_ellipsis (_tmp354_);
								_tmp356_ = _tmp355_;
								if (_tmp356_) {
									_vala_code_node_unref0 (param);
									break;
								}
								_tmp357_ = arg_it;
								vala_iterator_next (_tmp357_);
								_vala_code_node_unref0 (param);
							}
							_vala_iterable_unref0 (_param_list);
						}
					}
				}
			}
			_tmp358_ = format_literal;
			if (_tmp358_ != NULL) {
				gchar* format = NULL;
				ValaStringLiteral* _tmp359_;
				gchar* _tmp360_;
				ValaSemanticAnalyzer* _tmp361_;
				ValaSemanticAnalyzer* _tmp362_;
				const gchar* _tmp363_;
				ValaIterator* _tmp364_;
				ValaSourceReference* _tmp365_;
				ValaSourceReference* _tmp366_;
				_tmp359_ = format_literal;
				_tmp360_ = vala_string_literal_eval (_tmp359_);
				format = _tmp360_;
				_tmp361_ = vala_code_context_get_analyzer (context);
				_tmp362_ = _tmp361_;
				_tmp363_ = format;
				_tmp364_ = arg_it;
				_tmp365_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp366_ = _tmp365_;
				if (!vala_semantic_analyzer_check_print_format (_tmp362_, _tmp363_, _tmp364_, _tmp366_)) {
					result = FALSE;
					_g_free0 (format);
					_vala_code_node_unref0 (format_literal);
					_vala_iterator_unref0 (arg_it);
					_vala_iterable_unref0 (args);
					_vala_code_node_unref0 (last_arg);
					_vala_code_node_unref0 (m);
					_vala_code_node_unref0 (type);
					return result;
				}
				_g_free0 (format);
			}
			_vala_code_node_unref0 (format_literal);
		}
		{
			ValaList* _arg_list = NULL;
			ValaList* _tmp367_;
			ValaList* _tmp368_;
			gint _arg_size = 0;
			ValaList* _tmp369_;
			gint _tmp370_;
			gint _tmp371_;
			gint _arg_index = 0;
			_tmp367_ = args;
			_tmp368_ = _vala_iterable_ref0 (_tmp367_);
			_arg_list = _tmp368_;
			_tmp369_ = _arg_list;
			_tmp370_ = vala_collection_get_size ((ValaCollection*) _tmp369_);
			_tmp371_ = _tmp370_;
			_arg_size = _tmp371_;
			_arg_index = -1;
			while (TRUE) {
				ValaExpression* arg = NULL;
				ValaList* _tmp372_;
				gpointer _tmp373_;
				ValaExpression* _tmp374_;
				_arg_index = _arg_index + 1;
				if (!(_arg_index < _arg_size)) {
					break;
				}
				_tmp372_ = _arg_list;
				_tmp373_ = vala_list_get (_tmp372_, _arg_index);
				arg = (ValaExpression*) _tmp373_;
				_tmp374_ = arg;
				vala_code_node_check ((ValaCodeNode*) _tmp374_, context);
				_vala_code_node_unref0 (arg);
			}
			_vala_iterable_unref0 (_arg_list);
		}
		_tmp375_ = vala_code_context_get_analyzer (context);
		_tmp376_ = _tmp375_;
		_tmp377_ = m;
		_tmp378_ = vala_method_type_new (_tmp377_);
		_tmp379_ = _tmp378_;
		_tmp380_ = m;
		_tmp381_ = vala_callable_get_parameters ((ValaCallable*) _tmp380_);
		_tmp382_ = _tmp381_;
		_tmp383_ = args;
		vala_semantic_analyzer_check_arguments (_tmp376_, (ValaExpression*) self, (ValaDataType*) _tmp379_, _tmp382_, _tmp383_);
		_vala_iterable_unref0 (_tmp382_);
		_vala_code_node_unref0 (_tmp379_);
		_vala_iterator_unref0 (arg_it);
		_vala_iterable_unref0 (args);
		_vala_code_node_unref0 (last_arg);
		_vala_code_node_unref0 (m);
	} else {
		ValaDataType* _tmp384_;
		ValaDataType* _tmp385_;
		_tmp384_ = vala_object_creation_expression_get_type_reference (self);
		_tmp385_ = _tmp384_;
		if (VALA_IS_ERROR_TYPE (_tmp385_)) {
			ValaDataType* _tmp386_;
			ValaDataType* _tmp387_;
			ValaMemberAccess* _tmp390_;
			ValaMemberAccess* _tmp391_;
			ValaList* _tmp410_;
			ValaList* _tmp411_;
			gint _tmp412_;
			gint _tmp413_;
			gboolean _tmp414_;
			_tmp386_ = vala_object_creation_expression_get_type_reference (self);
			_tmp387_ = _tmp386_;
			if (_tmp387_ != NULL) {
				ValaDataType* _tmp388_;
				ValaDataType* _tmp389_;
				_tmp388_ = vala_object_creation_expression_get_type_reference (self);
				_tmp389_ = _tmp388_;
				vala_code_node_check ((ValaCodeNode*) _tmp389_, context);
			}
			_tmp390_ = vala_object_creation_expression_get_member_name (self);
			_tmp391_ = _tmp390_;
			if (_tmp391_ != NULL) {
				ValaMemberAccess* _tmp392_;
				ValaMemberAccess* _tmp393_;
				_tmp392_ = vala_object_creation_expression_get_member_name (self);
				_tmp393_ = _tmp392_;
				vala_code_node_check ((ValaCodeNode*) _tmp393_, context);
			}
			{
				ValaList* _arg_list = NULL;
				ValaList* _tmp394_;
				ValaList* _tmp395_;
				gint _arg_size = 0;
				ValaList* _tmp396_;
				gint _tmp397_;
				gint _tmp398_;
				gint _arg_index = 0;
				_tmp394_ = self->priv->argument_list;
				_tmp395_ = _vala_iterable_ref0 (_tmp394_);
				_arg_list = _tmp395_;
				_tmp396_ = _arg_list;
				_tmp397_ = vala_collection_get_size ((ValaCollection*) _tmp396_);
				_tmp398_ = _tmp397_;
				_arg_size = _tmp398_;
				_arg_index = -1;
				while (TRUE) {
					ValaExpression* arg = NULL;
					ValaList* _tmp399_;
					gpointer _tmp400_;
					ValaExpression* _tmp401_;
					_arg_index = _arg_index + 1;
					if (!(_arg_index < _arg_size)) {
						break;
					}
					_tmp399_ = _arg_list;
					_tmp400_ = vala_list_get (_tmp399_, _arg_index);
					arg = (ValaExpression*) _tmp400_;
					_tmp401_ = arg;
					vala_code_node_check ((ValaCodeNode*) _tmp401_, context);
					_vala_code_node_unref0 (arg);
				}
				_vala_iterable_unref0 (_arg_list);
			}
			{
				ValaList* _init_list = NULL;
				ValaList* _tmp402_;
				ValaList* _tmp403_;
				gint _init_size = 0;
				ValaList* _tmp404_;
				gint _tmp405_;
				gint _tmp406_;
				gint _init_index = 0;
				_tmp402_ = self->priv->object_initializer;
				_tmp403_ = _vala_iterable_ref0 (_tmp402_);
				_init_list = _tmp403_;
				_tmp404_ = _init_list;
				_tmp405_ = vala_collection_get_size ((ValaCollection*) _tmp404_);
				_tmp406_ = _tmp405_;
				_init_size = _tmp406_;
				_init_index = -1;
				while (TRUE) {
					ValaMemberInitializer* init = NULL;
					ValaList* _tmp407_;
					gpointer _tmp408_;
					ValaMemberInitializer* _tmp409_;
					_init_index = _init_index + 1;
					if (!(_init_index < _init_size)) {
						break;
					}
					_tmp407_ = _init_list;
					_tmp408_ = vala_list_get (_tmp407_, _init_index);
					init = (ValaMemberInitializer*) _tmp408_;
					_tmp409_ = init;
					vala_code_node_check ((ValaCodeNode*) _tmp409_, context);
					_vala_code_node_unref0 (init);
				}
				_vala_iterable_unref0 (_init_list);
			}
			_tmp410_ = vala_object_creation_expression_get_argument_list (self);
			_tmp411_ = _tmp410_;
			_tmp412_ = vala_collection_get_size ((ValaCollection*) _tmp411_);
			_tmp413_ = _tmp412_;
			_tmp414_ = _tmp413_ == 0;
			_vala_iterable_unref0 (_tmp411_);
			if (_tmp414_) {
				ValaSourceReference* _tmp415_;
				ValaSourceReference* _tmp416_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp415_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp416_ = _tmp415_;
				vala_report_error (_tmp416_, "Too few arguments, errors need at least 1 argument");
			} else {
				ValaIterator* arg_it = NULL;
				ValaList* _tmp417_;
				ValaList* _tmp418_;
				ValaIterator* _tmp419_;
				ValaIterator* _tmp420_;
				ValaIterator* _tmp421_;
				ValaExpression* ex = NULL;
				ValaIterator* _tmp422_;
				gpointer _tmp423_;
				gboolean _tmp424_ = FALSE;
				ValaExpression* _tmp425_;
				ValaDataType* _tmp426_;
				ValaDataType* _tmp427_;
				ValaStringLiteral* format_literal = NULL;
				ValaExpression* _tmp436_;
				ValaStringLiteral* _tmp437_;
				ValaStringLiteral* _tmp438_;
				ValaList* _tmp447_;
				ValaList* _tmp448_;
				ValaIterator* _tmp449_;
				ValaIterator* _tmp450_;
				ValaSemanticAnalyzer* _tmp451_;
				ValaSemanticAnalyzer* _tmp452_;
				ValaIterator* _tmp453_;
				ValaSourceReference* _tmp454_;
				ValaSourceReference* _tmp455_;
				_tmp417_ = vala_object_creation_expression_get_argument_list (self);
				_tmp418_ = _tmp417_;
				_tmp419_ = vala_iterable_iterator ((ValaIterable*) _tmp418_);
				_tmp420_ = _tmp419_;
				_vala_iterable_unref0 (_tmp418_);
				arg_it = _tmp420_;
				_tmp421_ = arg_it;
				vala_iterator_next (_tmp421_);
				_tmp422_ = arg_it;
				_tmp423_ = vala_iterator_get (_tmp422_);
				ex = (ValaExpression*) _tmp423_;
				_tmp425_ = ex;
				_tmp426_ = vala_expression_get_value_type (_tmp425_);
				_tmp427_ = _tmp426_;
				if (_tmp427_ == NULL) {
					_tmp424_ = TRUE;
				} else {
					ValaExpression* _tmp428_;
					ValaDataType* _tmp429_;
					ValaDataType* _tmp430_;
					ValaSemanticAnalyzer* _tmp431_;
					ValaSemanticAnalyzer* _tmp432_;
					ValaDataType* _tmp433_;
					_tmp428_ = ex;
					_tmp429_ = vala_expression_get_value_type (_tmp428_);
					_tmp430_ = _tmp429_;
					_tmp431_ = vala_code_context_get_analyzer (context);
					_tmp432_ = _tmp431_;
					_tmp433_ = _tmp432_->string_type;
					_tmp424_ = !vala_data_type_compatible (_tmp430_, _tmp433_);
				}
				if (_tmp424_) {
					ValaSourceReference* _tmp434_;
					ValaSourceReference* _tmp435_;
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					_tmp434_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp435_ = _tmp434_;
					vala_report_error (_tmp435_, "Invalid type for argument 1");
				}
				_tmp436_ = ex;
				_tmp437_ = vala_string_literal_get_format_literal (_tmp436_);
				format_literal = _tmp437_;
				_tmp438_ = format_literal;
				if (_tmp438_ != NULL) {
					gchar* format = NULL;
					ValaStringLiteral* _tmp439_;
					gchar* _tmp440_;
					ValaSemanticAnalyzer* _tmp441_;
					ValaSemanticAnalyzer* _tmp442_;
					const gchar* _tmp443_;
					ValaIterator* _tmp444_;
					ValaSourceReference* _tmp445_;
					ValaSourceReference* _tmp446_;
					_tmp439_ = format_literal;
					_tmp440_ = vala_string_literal_eval (_tmp439_);
					format = _tmp440_;
					_tmp441_ = vala_code_context_get_analyzer (context);
					_tmp442_ = _tmp441_;
					_tmp443_ = format;
					_tmp444_ = arg_it;
					_tmp445_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp446_ = _tmp445_;
					if (!vala_semantic_analyzer_check_print_format (_tmp442_, _tmp443_, _tmp444_, _tmp446_)) {
						vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
						result = FALSE;
						_g_free0 (format);
						_vala_code_node_unref0 (format_literal);
						_vala_code_node_unref0 (ex);
						_vala_iterator_unref0 (arg_it);
						_vala_code_node_unref0 (type);
						return result;
					}
					_g_free0 (format);
				}
				_tmp447_ = vala_object_creation_expression_get_argument_list (self);
				_tmp448_ = _tmp447_;
				_tmp449_ = vala_iterable_iterator ((ValaIterable*) _tmp448_);
				_vala_iterator_unref0 (arg_it);
				arg_it = _tmp449_;
				_vala_iterable_unref0 (_tmp448_);
				_tmp450_ = arg_it;
				vala_iterator_next (_tmp450_);
				_tmp451_ = vala_code_context_get_analyzer (context);
				_tmp452_ = _tmp451_;
				_tmp453_ = arg_it;
				_tmp454_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp455_ = _tmp454_;
				if (!vala_semantic_analyzer_check_variadic_arguments (_tmp452_, _tmp453_, 1, _tmp455_)) {
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					result = FALSE;
					_vala_code_node_unref0 (format_literal);
					_vala_code_node_unref0 (ex);
					_vala_iterator_unref0 (arg_it);
					_vala_code_node_unref0 (type);
					return result;
				}
				_vala_code_node_unref0 (format_literal);
				_vala_code_node_unref0 (ex);
				_vala_iterator_unref0 (arg_it);
			}
		}
	}
	{
		ValaList* _arg_list = NULL;
		ValaList* _tmp456_;
		gint _arg_size = 0;
		ValaList* _tmp457_;
		gint _tmp458_;
		gint _tmp459_;
		gint _arg_index = 0;
		_tmp456_ = vala_object_creation_expression_get_argument_list (self);
		_arg_list = _tmp456_;
		_tmp457_ = _arg_list;
		_tmp458_ = vala_collection_get_size ((ValaCollection*) _tmp457_);
		_tmp459_ = _tmp458_;
		_arg_size = _tmp459_;
		_arg_index = -1;
		while (TRUE) {
			ValaExpression* arg = NULL;
			ValaList* _tmp460_;
			gpointer _tmp461_;
			ValaSizeofExpression* sizeof_expr = NULL;
			ValaExpression* _tmp462_;
			gboolean _tmp463_ = FALSE;
			ValaSizeofExpression* _tmp464_;
			_arg_index = _arg_index + 1;
			if (!(_arg_index < _arg_size)) {
				break;
			}
			_tmp460_ = _arg_list;
			_tmp461_ = vala_list_get (_tmp460_, _arg_index);
			arg = (ValaExpression*) _tmp461_;
			_tmp462_ = arg;
			sizeof_expr = VALA_IS_SIZEOF_EXPRESSION (_tmp462_) ? ((ValaSizeofExpression*) _tmp462_) : NULL;
			_tmp464_ = sizeof_expr;
			if (_tmp464_ != NULL) {
				ValaSizeofExpression* _tmp465_;
				ValaDataType* _tmp466_;
				ValaDataType* _tmp467_;
				_tmp465_ = sizeof_expr;
				_tmp466_ = vala_sizeof_expression_get_type_reference (_tmp465_);
				_tmp467_ = _tmp466_;
				_tmp463_ = VALA_IS_GENERIC_TYPE (_tmp467_);
			} else {
				_tmp463_ = FALSE;
			}
			if (_tmp463_) {
				ValaDataType* sizeof_type = NULL;
				ValaSizeofExpression* _tmp468_;
				ValaDataType* _tmp469_;
				ValaDataType* _tmp470_;
				ValaDataType* _tmp471_;
				ValaDataType* _tmp472_;
				ValaDataType* _tmp473_;
				ValaDataType* _tmp474_;
				ValaList* _tmp475_;
				ValaList* _tmp476_;
				ValaDataType* _tmp477_;
				ValaDataType* _tmp478_;
				ValaExpression* _tmp479_;
				ValaDataType* _tmp480_;
				ValaSourceReference* _tmp481_;
				ValaSourceReference* _tmp482_;
				ValaSizeofExpression* _tmp483_;
				ValaSizeofExpression* _tmp484_;
				_tmp468_ = sizeof_expr;
				_tmp469_ = vala_sizeof_expression_get_type_reference (_tmp468_);
				_tmp470_ = _tmp469_;
				_tmp471_ = vala_object_creation_expression_get_type_reference (self);
				_tmp472_ = _tmp471_;
				_tmp473_ = vala_object_creation_expression_get_type_reference (self);
				_tmp474_ = _tmp473_;
				_tmp475_ = vala_data_type_get_type_arguments (_tmp474_);
				_tmp476_ = _tmp475_;
				_tmp477_ = vala_data_type_get_actual_type (_tmp470_, _tmp472_, _tmp476_, (ValaCodeNode*) self);
				_tmp478_ = _tmp477_;
				_vala_iterable_unref0 (_tmp476_);
				sizeof_type = _tmp478_;
				_tmp479_ = arg;
				_tmp480_ = sizeof_type;
				_tmp481_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp482_ = _tmp481_;
				_tmp483_ = vala_sizeof_expression_new (_tmp480_, _tmp482_);
				_tmp484_ = _tmp483_;
				vala_code_node_replace_expression ((ValaCodeNode*) self, _tmp479_, (ValaExpression*) _tmp484_);
				_vala_code_node_unref0 (_tmp484_);
				_vala_code_node_unref0 (sizeof_type);
			}
			_vala_code_node_unref0 (arg);
		}
		_vala_iterable_unref0 (_arg_list);
	}
	{
		ValaList* _init_list = NULL;
		ValaList* _tmp485_;
		gint _init_size = 0;
		ValaList* _tmp486_;
		gint _tmp487_;
		gint _tmp488_;
		gint _init_index = 0;
		_tmp485_ = vala_object_creation_expression_get_object_initializer (self);
		_init_list = _tmp485_;
		_tmp486_ = _init_list;
		_tmp487_ = vala_collection_get_size ((ValaCollection*) _tmp486_);
		_tmp488_ = _tmp487_;
		_init_size = _tmp488_;
		_init_index = -1;
		while (TRUE) {
			ValaMemberInitializer* init = NULL;
			ValaList* _tmp489_;
			gpointer _tmp490_;
			ValaSemanticAnalyzer* _tmp491_;
			ValaSemanticAnalyzer* _tmp492_;
			ValaMemberInitializer* _tmp493_;
			ValaDataType* _tmp494_;
			ValaDataType* _tmp495_;
			_init_index = _init_index + 1;
			if (!(_init_index < _init_size)) {
				break;
			}
			_tmp489_ = _init_list;
			_tmp490_ = vala_list_get (_tmp489_, _init_index);
			init = (ValaMemberInitializer*) _tmp490_;
			_tmp491_ = vala_code_context_get_analyzer (context);
			_tmp492_ = _tmp491_;
			_tmp493_ = init;
			_tmp494_ = vala_object_creation_expression_get_type_reference (self);
			_tmp495_ = _tmp494_;
			vala_semantic_analyzer_visit_member_initializer (_tmp492_, _tmp493_, _tmp495_);
			_vala_code_node_unref0 (init);
		}
		_vala_iterable_unref0 (_init_list);
	}
	_tmp496_ = vala_code_node_get_tree_can_fail ((ValaCodeNode*) self);
	_tmp497_ = _tmp496_;
	if (_tmp497_) {
		gboolean _tmp498_ = FALSE;
		ValaCodeNode* _tmp499_;
		ValaCodeNode* _tmp500_;
		_tmp499_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
		_tmp500_ = _tmp499_;
		if (VALA_IS_LOCAL_VARIABLE (_tmp500_)) {
			_tmp498_ = TRUE;
		} else {
			ValaCodeNode* _tmp501_;
			ValaCodeNode* _tmp502_;
			_tmp501_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
			_tmp502_ = _tmp501_;
			_tmp498_ = VALA_IS_EXPRESSION_STATEMENT (_tmp502_);
		}
		if (_tmp498_) {
		} else {
			ValaSemanticAnalyzer* _tmp503_;
			ValaSemanticAnalyzer* _tmp504_;
			ValaSymbol* _tmp505_;
			ValaSymbol* _tmp506_;
			_tmp503_ = vala_code_context_get_analyzer (context);
			_tmp504_ = _tmp503_;
			_tmp505_ = vala_semantic_analyzer_get_current_symbol (_tmp504_);
			_tmp506_ = _tmp505_;
			if (!VALA_IS_BLOCK (_tmp506_)) {
				ValaSourceReference* _tmp507_;
				ValaSourceReference* _tmp508_;
				_tmp507_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp508_ = _tmp507_;
				vala_report_error (_tmp508_, "Field initializers must not throw errors");
			} else {
				ValaCodeNode* old_parent_node = NULL;
				ValaCodeNode* _tmp509_;
				ValaCodeNode* _tmp510_;
				ValaCodeNode* _tmp511_;
				ValaLocalVariable* local = NULL;
				ValaDataType* _tmp512_;
				ValaDataType* _tmp513_;
				ValaDataType* _tmp514_;
				ValaDataType* _tmp515_;
				gchar* _tmp516_;
				gchar* _tmp517_;
				ValaSourceReference* _tmp518_;
				ValaSourceReference* _tmp519_;
				ValaLocalVariable* _tmp520_;
				ValaLocalVariable* _tmp521_;
				ValaDeclarationStatement* decl = NULL;
				ValaLocalVariable* _tmp522_;
				ValaSourceReference* _tmp523_;
				ValaSourceReference* _tmp524_;
				ValaDeclarationStatement* _tmp525_;
				ValaSemanticAnalyzer* _tmp526_;
				ValaSemanticAnalyzer* _tmp527_;
				ValaBlock* _tmp528_;
				ValaDeclarationStatement* _tmp529_;
				ValaExpression* temp_access = NULL;
				ValaLocalVariable* _tmp530_;
				ValaDataType* _tmp531_;
				ValaDataType* _tmp532_;
				ValaExpression* _tmp533_;
				ValaLocalVariable* _tmp534_;
				ValaDeclarationStatement* _tmp535_;
				ValaBlock* block = NULL;
				ValaSemanticAnalyzer* _tmp536_;
				ValaSemanticAnalyzer* _tmp537_;
				ValaSymbol* _tmp538_;
				ValaSymbol* _tmp539_;
				ValaBlock* _tmp540_;
				ValaBlock* _tmp541_;
				ValaLocalVariable* _tmp542_;
				ValaSemanticAnalyzer* _tmp543_;
				ValaSemanticAnalyzer* _tmp544_;
				ValaBlock* _tmp545_;
				ValaLocalVariable* _tmp546_;
				ValaCodeNode* _tmp547_;
				ValaExpression* _tmp548_;
				ValaExpression* _tmp549_;
				_tmp509_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
				_tmp510_ = _tmp509_;
				_tmp511_ = _vala_code_node_ref0 (_tmp510_);
				old_parent_node = _tmp511_;
				_tmp512_ = vala_expression_get_value_type ((ValaExpression*) self);
				_tmp513_ = _tmp512_;
				_tmp514_ = vala_data_type_copy (_tmp513_);
				_tmp515_ = _tmp514_;
				_tmp516_ = vala_code_node_get_temp_name ();
				_tmp517_ = _tmp516_;
				_tmp518_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp519_ = _tmp518_;
				_tmp520_ = vala_local_variable_new (_tmp515_, _tmp517_, NULL, _tmp519_);
				_tmp521_ = _tmp520_;
				_g_free0 (_tmp517_);
				_vala_code_node_unref0 (_tmp515_);
				local = _tmp521_;
				_tmp522_ = local;
				_tmp523_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp524_ = _tmp523_;
				_tmp525_ = vala_declaration_statement_new ((ValaSymbol*) _tmp522_, _tmp524_);
				decl = _tmp525_;
				_tmp526_ = vala_code_context_get_analyzer (context);
				_tmp527_ = _tmp526_;
				_tmp528_ = _tmp527_->insert_block;
				_tmp529_ = decl;
				vala_expression_insert_statement ((ValaExpression*) self, _tmp528_, (ValaStatement*) _tmp529_);
				_tmp530_ = local;
				_tmp531_ = vala_expression_get_target_type ((ValaExpression*) self);
				_tmp532_ = _tmp531_;
				_tmp533_ = vala_semantic_analyzer_create_temp_access (_tmp530_, _tmp532_);
				temp_access = _tmp533_;
				_tmp534_ = local;
				vala_variable_set_initializer ((ValaVariable*) _tmp534_, (ValaExpression*) self);
				_tmp535_ = decl;
				vala_code_node_check ((ValaCodeNode*) _tmp535_, context);
				_tmp536_ = vala_code_context_get_analyzer (context);
				_tmp537_ = _tmp536_;
				_tmp538_ = vala_semantic_analyzer_get_current_symbol (_tmp537_);
				_tmp539_ = _tmp538_;
				_tmp540_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp539_, VALA_TYPE_BLOCK, ValaBlock));
				block = _tmp540_;
				_tmp541_ = block;
				_tmp542_ = local;
				vala_block_remove_local_variable (_tmp541_, _tmp542_);
				_tmp543_ = vala_code_context_get_analyzer (context);
				_tmp544_ = _tmp543_;
				_tmp545_ = _tmp544_->insert_block;
				_tmp546_ = local;
				vala_block_add_local_variable (_tmp545_, _tmp546_);
				_tmp547_ = old_parent_node;
				_tmp548_ = temp_access;
				vala_code_node_replace_expression (_tmp547_, (ValaExpression*) self, _tmp548_);
				_tmp549_ = temp_access;
				vala_code_node_check ((ValaCodeNode*) _tmp549_, context);
				_vala_code_node_unref0 (block);
				_vala_code_node_unref0 (temp_access);
				_vala_code_node_unref0 (decl);
				_vala_code_node_unref0 (local);
				_vala_code_node_unref0 (old_parent_node);
			}
		}
	}
	_tmp550_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp551_ = _tmp550_;
	result = !_tmp551_;
	_vala_code_node_unref0 (type);
	return result;
}

static void
vala_object_creation_expression_real_get_error_types (ValaCodeNode* base,
                                                      ValaCollection* collection,
                                                      ValaSourceReference* source_reference)
{
	ValaObjectCreationExpression * self;
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	self = (ValaObjectCreationExpression*) base;
	g_return_if_fail (collection != NULL);
	_tmp0_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
	_tmp1_ = _tmp0_;
	if (VALA_IS_METHOD (_tmp1_)) {
		ValaMethod* m = NULL;
		ValaSymbol* _tmp4_;
		ValaSymbol* _tmp5_;
		ValaMethod* _tmp6_;
		ValaMethod* _tmp7_;
		if (source_reference == NULL) {
			ValaSourceReference* _tmp2_;
			ValaSourceReference* _tmp3_;
			_tmp2_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp3_ = _tmp2_;
			source_reference = _tmp3_;
		}
		_tmp4_ = vala_expression_get_symbol_reference ((ValaExpression*) self);
		_tmp5_ = _tmp4_;
		_tmp6_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, VALA_TYPE_METHOD, ValaMethod));
		m = _tmp6_;
		_tmp7_ = m;
		vala_code_node_get_error_types ((ValaCodeNode*) _tmp7_, collection, source_reference);
		_vala_code_node_unref0 (m);
	}
}

static void
vala_object_creation_expression_real_emit (ValaCodeNode* base,
                                           ValaCodeGenerator* codegen)
{
	ValaObjectCreationExpression * self;
	self = (ValaObjectCreationExpression*) base;
	g_return_if_fail (codegen != NULL);
	{
		ValaList* _arg_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _arg_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _arg_index = 0;
		_tmp0_ = self->priv->argument_list;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_arg_list = _tmp1_;
		_tmp2_ = _arg_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_arg_size = _tmp4_;
		_arg_index = -1;
		while (TRUE) {
			ValaExpression* arg = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_arg_index = _arg_index + 1;
			if (!(_arg_index < _arg_size)) {
				break;
			}
			_tmp5_ = _arg_list;
			_tmp6_ = vala_list_get (_tmp5_, _arg_index);
			arg = (ValaExpression*) _tmp6_;
			_tmp7_ = arg;
			vala_code_node_emit ((ValaCodeNode*) _tmp7_, codegen);
			_vala_code_node_unref0 (arg);
		}
		_vala_iterable_unref0 (_arg_list);
	}
	{
		ValaList* _init_list = NULL;
		ValaList* _tmp8_;
		ValaList* _tmp9_;
		gint _init_size = 0;
		ValaList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _init_index = 0;
		_tmp8_ = self->priv->object_initializer;
		_tmp9_ = _vala_iterable_ref0 (_tmp8_);
		_init_list = _tmp9_;
		_tmp10_ = _init_list;
		_tmp11_ = vala_collection_get_size ((ValaCollection*) _tmp10_);
		_tmp12_ = _tmp11_;
		_init_size = _tmp12_;
		_init_index = -1;
		while (TRUE) {
			ValaMemberInitializer* init = NULL;
			ValaList* _tmp13_;
			gpointer _tmp14_;
			ValaMemberInitializer* _tmp15_;
			_init_index = _init_index + 1;
			if (!(_init_index < _init_size)) {
				break;
			}
			_tmp13_ = _init_list;
			_tmp14_ = vala_list_get (_tmp13_, _init_index);
			init = (ValaMemberInitializer*) _tmp14_;
			_tmp15_ = init;
			vala_code_node_emit ((ValaCodeNode*) _tmp15_, codegen);
			_vala_code_node_unref0 (init);
		}
		_vala_iterable_unref0 (_init_list);
	}
	vala_code_visitor_visit_object_creation_expression ((ValaCodeVisitor*) codegen, self);
	vala_code_visitor_visit_expression ((ValaCodeVisitor*) codegen, (ValaExpression*) self);
}

static void
vala_object_creation_expression_real_get_defined_variables (ValaCodeNode* base,
                                                            ValaCollection* collection)
{
	ValaObjectCreationExpression * self;
	self = (ValaObjectCreationExpression*) base;
	g_return_if_fail (collection != NULL);
	{
		ValaList* _arg_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _arg_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _arg_index = 0;
		_tmp0_ = self->priv->argument_list;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_arg_list = _tmp1_;
		_tmp2_ = _arg_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_arg_size = _tmp4_;
		_arg_index = -1;
		while (TRUE) {
			ValaExpression* arg = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_arg_index = _arg_index + 1;
			if (!(_arg_index < _arg_size)) {
				break;
			}
			_tmp5_ = _arg_list;
			_tmp6_ = vala_list_get (_tmp5_, _arg_index);
			arg = (ValaExpression*) _tmp6_;
			_tmp7_ = arg;
			vala_code_node_get_defined_variables ((ValaCodeNode*) _tmp7_, collection);
			_vala_code_node_unref0 (arg);
		}
		_vala_iterable_unref0 (_arg_list);
	}
}

static void
vala_object_creation_expression_real_get_used_variables (ValaCodeNode* base,
                                                         ValaCollection* collection)
{
	ValaObjectCreationExpression * self;
	self = (ValaObjectCreationExpression*) base;
	g_return_if_fail (collection != NULL);
	{
		ValaList* _arg_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _arg_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _arg_index = 0;
		_tmp0_ = self->priv->argument_list;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_arg_list = _tmp1_;
		_tmp2_ = _arg_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_arg_size = _tmp4_;
		_arg_index = -1;
		while (TRUE) {
			ValaExpression* arg = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_arg_index = _arg_index + 1;
			if (!(_arg_index < _arg_size)) {
				break;
			}
			_tmp5_ = _arg_list;
			_tmp6_ = vala_list_get (_tmp5_, _arg_index);
			arg = (ValaExpression*) _tmp6_;
			_tmp7_ = arg;
			vala_code_node_get_used_variables ((ValaCodeNode*) _tmp7_, collection);
			_vala_code_node_unref0 (arg);
		}
		_vala_iterable_unref0 (_arg_list);
	}
	{
		ValaList* _init_list = NULL;
		ValaList* _tmp8_;
		ValaList* _tmp9_;
		gint _init_size = 0;
		ValaList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _init_index = 0;
		_tmp8_ = self->priv->object_initializer;
		_tmp9_ = _vala_iterable_ref0 (_tmp8_);
		_init_list = _tmp9_;
		_tmp10_ = _init_list;
		_tmp11_ = vala_collection_get_size ((ValaCollection*) _tmp10_);
		_tmp12_ = _tmp11_;
		_init_size = _tmp12_;
		_init_index = -1;
		while (TRUE) {
			ValaMemberInitializer* init = NULL;
			ValaList* _tmp13_;
			gpointer _tmp14_;
			ValaMemberInitializer* _tmp15_;
			_init_index = _init_index + 1;
			if (!(_init_index < _init_size)) {
				break;
			}
			_tmp13_ = _init_list;
			_tmp14_ = vala_list_get (_tmp13_, _init_index);
			init = (ValaMemberInitializer*) _tmp14_;
			_tmp15_ = init;
			vala_code_node_get_used_variables ((ValaCodeNode*) _tmp15_, collection);
			_vala_code_node_unref0 (init);
		}
		_vala_iterable_unref0 (_init_list);
	}
}

ValaDataType*
vala_object_creation_expression_get_type_reference (ValaObjectCreationExpression* self)
{
	ValaDataType* result;
	ValaDataType* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_data_type;
	result = _tmp0_;
	return result;
}

void
vala_object_creation_expression_set_type_reference (ValaObjectCreationExpression* self,
                                                    ValaDataType* value)
{
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_data_type);
	self->priv->_data_type = _tmp0_;
	_tmp1_ = self->priv->_data_type;
	vala_code_node_set_parent_node ((ValaCodeNode*) _tmp1_, (ValaCodeNode*) self);
}

ValaMemberAccess*
vala_object_creation_expression_get_member_name (ValaObjectCreationExpression* self)
{
	ValaMemberAccess* result;
	ValaMemberAccess* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_member_name;
	result = _tmp0_;
	return result;
}

void
vala_object_creation_expression_set_member_name (ValaObjectCreationExpression* self,
                                                 ValaMemberAccess* value)
{
	ValaMemberAccess* _tmp0_;
	ValaMemberAccess* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_member_name);
	self->priv->_member_name = _tmp0_;
	_tmp1_ = self->priv->_member_name;
	if (_tmp1_ != NULL) {
		ValaMemberAccess* _tmp2_;
		_tmp2_ = self->priv->_member_name;
		vala_code_node_set_parent_node ((ValaCodeNode*) _tmp2_, (ValaCodeNode*) self);
	}
}

gboolean
vala_object_creation_expression_get_is_yield_expression (ValaObjectCreationExpression* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_yield_expression;
	return result;
}

void
vala_object_creation_expression_set_is_yield_expression (ValaObjectCreationExpression* self,
                                                         gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_yield_expression = value;
}

gboolean
vala_object_creation_expression_get_struct_creation (ValaObjectCreationExpression* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_struct_creation;
	return result;
}

void
vala_object_creation_expression_set_struct_creation (ValaObjectCreationExpression* self,
                                                     gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_struct_creation = value;
}

static void
vala_object_creation_expression_class_init (ValaObjectCreationExpressionClass * klass,
                                            gpointer klass_data)
{
	vala_object_creation_expression_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_object_creation_expression_finalize;
	g_type_class_adjust_private_offset (klass, &ValaObjectCreationExpression_private_offset);
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_object_creation_expression_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_object_creation_expression_real_accept_children;
	((ValaCodeNodeClass *) klass)->replace_expression = (void (*) (ValaCodeNode*, ValaExpression*, ValaExpression*)) vala_object_creation_expression_real_replace_expression;
	((ValaExpressionClass *) klass)->is_pure = (gboolean (*) (ValaExpression*)) vala_object_creation_expression_real_is_pure;
	((ValaExpressionClass *) klass)->is_accessible = (gboolean (*) (ValaExpression*, ValaSymbol*)) vala_object_creation_expression_real_is_accessible;
	((ValaCodeNodeClass *) klass)->replace_type = (void (*) (ValaCodeNode*, ValaDataType*, ValaDataType*)) vala_object_creation_expression_real_replace_type;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode*, ValaCodeContext*)) vala_object_creation_expression_real_check;
	((ValaCodeNodeClass *) klass)->get_error_types = (void (*) (ValaCodeNode*, ValaCollection*, ValaSourceReference*)) vala_object_creation_expression_real_get_error_types;
	((ValaCodeNodeClass *) klass)->emit = (void (*) (ValaCodeNode*, ValaCodeGenerator*)) vala_object_creation_expression_real_emit;
	((ValaCodeNodeClass *) klass)->get_defined_variables = (void (*) (ValaCodeNode*, ValaCollection*)) vala_object_creation_expression_real_get_defined_variables;
	((ValaCodeNodeClass *) klass)->get_used_variables = (void (*) (ValaCodeNode*, ValaCollection*)) vala_object_creation_expression_real_get_used_variables;
}

static void
vala_object_creation_expression_instance_init (ValaObjectCreationExpression * self,
                                               gpointer klass)
{
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	GEqualFunc _tmp2_;
	ValaArrayList* _tmp3_;
	self->priv = vala_object_creation_expression_get_instance_private (self);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp0_);
	self->priv->argument_list = (ValaList*) _tmp1_;
	_tmp2_ = g_direct_equal;
	_tmp3_ = vala_array_list_new (VALA_TYPE_MEMBER_INITIALIZER, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp2_);
	self->priv->object_initializer = (ValaList*) _tmp3_;
}

static void
vala_object_creation_expression_finalize (ValaCodeNode * obj)
{
	ValaObjectCreationExpression * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_OBJECT_CREATION_EXPRESSION, ValaObjectCreationExpression);
	_vala_iterable_unref0 (self->priv->argument_list);
	_vala_iterable_unref0 (self->priv->object_initializer);
	_vala_code_node_unref0 (self->priv->_data_type);
	_vala_code_node_unref0 (self->priv->_member_name);
	VALA_CODE_NODE_CLASS (vala_object_creation_expression_parent_class)->finalize (obj);
}

/**
 * Represents an object creation expression in the source code.
 */
GType
vala_object_creation_expression_get_type (void)
{
	static volatile gsize vala_object_creation_expression_type_id__volatile = 0;
	if (g_once_init_enter (&vala_object_creation_expression_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaObjectCreationExpressionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_object_creation_expression_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaObjectCreationExpression), 0, (GInstanceInitFunc) vala_object_creation_expression_instance_init, NULL };
		GType vala_object_creation_expression_type_id;
		vala_object_creation_expression_type_id = g_type_register_static (VALA_TYPE_EXPRESSION, "ValaObjectCreationExpression", &g_define_type_info, 0);
		ValaObjectCreationExpression_private_offset = g_type_add_instance_private (vala_object_creation_expression_type_id, sizeof (ValaObjectCreationExpressionPrivate));
		g_once_init_leave (&vala_object_creation_expression_type_id__volatile, vala_object_creation_expression_type_id);
	}
	return vala_object_creation_expression_type_id__volatile;
}

